package com.xixun.xixunplayer;


import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.view.Choreographer;
import android.view.View;

import java.util.ArrayList;
import java.util.Random;

import gnph.util.JSList;
import gnph.util.JSMap;

public class EleFlip extends View implements DrawOther, Choreographer.FrameCallback {

    static final char effTypes[] = {'l', 't', 'r', 'b'};
    ArrayList<EleOtherPart> others;
    Random rand = new Random();
    ArrayList<Bitmap> imgs = new ArrayList<>();
    int picDur, EffDur, AniInterval, step, imgc, imgx, imgy;
    char effType;
    boolean needRand = false;

    public EleFlip(String dirPre, JSList<JSMap> maps, Context context) {
        super(context);
        var map = maps.get(0);
        picDur = map.intg("picDuration")*60;
        if(picDur==0) return;
        EffDur = map.intg("effectSpeed")*60;
        for(var amap : maps) imgs.add(BitmapFactory.decodeFile(dirPre+amap.stnn("id")));
        var effStr = map.str("effect");
        if(effStr == null || effStr.equals("no")) EffDur = 0;
        else if(effStr.endsWith("left")) effType = 'l';
        else if(effStr.endsWith("top")) effType = 't';
        else if(effStr.endsWith("right")) effType = 'r';
        else if(effStr.endsWith("bottom")) effType = 'b';
        else if(effStr.equals("random")) needRand = true;
        else EffDur = 0;
    }

    void startMove() {
        if(EffDur==0) return;
        if(needRand) effType = effTypes[rand.nextInt(4)];
        double effDurD = EffDur;
        if(effType=='l') {
            imgx = getWidth();
            imgy = 0;
            effDurD /= getWidth();
        } else if(effType=='r') {
            imgx = -getWidth();
            imgy = 0;
            effDurD /= getWidth();
        } else if(effType=='t') {
            imgx = 0;
            imgy = getHeight();
            effDurD /= getHeight();
        } else if(effType=='b') {
            imgx = 0;
            imgy = -getHeight();
            effDurD /= getHeight();
        } else return;
        AniInterval = (int) Math.round(effDurD);
        if(AniInterval < 1) AniInterval = 1;
        step = (int) Math.round(AniInterval / effDurD);
    }

    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        if(freshCnt==0 && (EffDur!=0 || imgs.size()>1)) {
            startMove();
            choreographer.postFrameCallback(this);
        }
        drawOther(canvas);
    }
    @Override
    public void drawOther(Canvas canvas) {
        canvas.drawBitmap(imgs.get(imgc), imgx, imgy, null);
    }

    Choreographer choreographer = Choreographer.getInstance();
    int freshCnt, curDur;

    @Override
    public void doFrame(long frameTimeNanos) {
        if(! isShown()) {
            freshCnt = curDur = imgc = 0;
            return;
        }
        if(curDur < picDur) {
            curDur++;
            if(AniInterval > 0) {
                if(freshCnt < AniInterval) freshCnt++;
                else {
                    freshCnt = 1;
                    if(effType=='l') {
                        imgx -= step;
                        if(imgx < 0) imgx = 0;
                    } else if(effType=='t') {
                        imgy -= step;
                        if(imgy < 0) imgy = 0;
                    } else if(effType=='r') {
                        imgx += step;
                        if(imgx > 0) imgx = 0;
                    } else if(effType=='b') {
                        imgy += step;
                        if(imgy > 0) imgy = 0;
                    }
                    if(imgx==0 && imgy==0) AniInterval = 0;
                    invalidate();
                    if(others!=null) for(var other : others) other.invalidate();
                }
            }
        } else {
            curDur = 0;
            freshCnt = 1;
            if(imgc >= imgs.size()-1) imgc = 0;
            else imgc++;
            startMove();
            invalidate();
            if(others!=null) for(var other : others) other.invalidate();
        }
        choreographer.postFrameCallback(this);
    }
}