package com.xixun.xixunplayer;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.view.Choreographer;
import android.view.View;

import gnph.util.Dates;
import gnph.util.JSMap;
import gnph.util.NumFmts;

public class EleTimer2 extends View implements Choreographer.FrameCallback {

    Paint paint = new Paint();
    long targetTime;
    String title, text;
    int x, y;
    boolean isDown;
    boolean isMultiline;
    boolean hasDay;
    boolean hasHour;
    boolean hasMin;
    boolean hasSec;

    public EleTimer2(JSMap json, Context context) {
        super(context);
        isDown = json.bool("isDown");
        targetTime = Dates.milli(json.stnn("targetTime")) / 1000;
        hasDay = json.bool("hasDay");
        hasHour = json.bool("hasHour");
        hasMin = json.bool("hasMin");
        hasSec = json.bool("hasSec");
        title = json.stnn("text");
        isMultiline = json.bool("isMultiline");
        int style = 0;
        if(json.bool("fontBold")) style |= 1;
        if(json.bool("fontItalic")) style |= 2;
        @SuppressLint("WrongConstant") var font = Typeface.create(json.stnn("font"), style);
        paint.setTypeface(font);
        paint.setTextSize(json.intg("fontSize"));
        paint.setUnderlineText(json.bool("fontUnderline"));
        paint.setColor(Color.parseColor(json.stnn("textColor")));
        paint.setTextAlign(Paint.Align.CENTER);
        try {
            setBackgroundColor(Color.parseColor(json.stnn("backColor")));
        } catch (Exception ignored) {}
    }

    @Override
    protected void onSizeChanged(int w, int h, int oldw, int oldh) {
        super.onSizeChanged(w, h, oldw, oldh);
        x = getWidth() / 2;
        var fontMetrics = paint.getFontMetrics();
        y = (int) (getHeight() - fontMetrics.top - fontMetrics.bottom) / 2;
    }

    void cal() {
        var cur = System.currentTimeMillis() / 1000;
        var secs = isDown ? targetTime - cur : cur - targetTime;
        if(secs < 0) secs = 0;
        var buf = new StringBuilder(title);
        if(buf.length() != 0) buf.append(isMultiline ? '\n' : ' ');
        if(hasDay) {
            buf.append(secs/86400).append(" ").append("day").append(" ");
            secs %= 86400;
        }
        if(hasHour) {
            buf.append(NumFmts.zz().format(secs/3600)).append("hour").append(" ");
            secs %= 3600;
        }
        if(hasMin) {
            buf.append(NumFmts.zz().format(secs/60)).append("min").append(" ");
            secs %= 60;
        }
        if(hasSec) buf.append(NumFmts.zz().format(secs)).append("sec").append(" ");
        text = buf.toString().trim();
    }

    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        if(lastSec==0) {
            cal();
            choreographer.postFrameCallback(this);
        }
        canvas.drawText(text, x, y, paint);
    }

    Choreographer choreographer = Choreographer.getInstance();
    long lastSec = 0;

    @Override
    public void doFrame(long frameTimeNanos) {
        if(! isShown()) {
            lastSec = 0;
            return;
        }
        var sec = frameTimeNanos / 1000000000;
        if(sec != lastSec) {
            lastSec = sec;
            cal();
            invalidate();
        }
        choreographer.postFrameCallback(this);
    }
}